;
; TI-Nuke for MSX...
; Clears your TI-83 calculator
;
; Conversion by Grauw, 1999
; email: laurensh1@yahoo.com
;
;
	org	#100
;
Bdos:	equ	5
;
;
Start:	ld	(save_SP),sp
	ld	de,TXT_PING
	ld	c,9
	call	Bdos

	ld	hl,DOESTHETRICK
	call	Send_Block
	ld	a,8	;Recieve 8 bytes and trash them
	call	Recv_A_Dummy

	ld	de,TXT_PONG
	ld	c,9
	call	Bdos

	ld	hl,REPLY_OK
	call	Send_Block

	ld	de,TXT_BOOM
	ld	c,9
	jp	Bdos


;
;Recieves A bytes and immediately trashes them.
;
Recv_A_Dummy:	push	af
	call	RecvByte
	pop	af
	dec	a
;              cp      0
	jr	nz,Recv_A_Dummy
	ret

;
;Sends a block of bytes until an #FF byte...
;
Send_Block:	ld	a,(hl)
	call	SendByte
	inc	hl
	ld	a,(hl)
	cp	#FF
	jr	nz,Send_Block
	ret

;
;Data...
;
TXT_PING:	DB	"Ping...$"
TXT_PONG:	DB	"Pong!",13,10,10,"$"
TXT_BOOM:	DB	"BOOM!!! Sorry :)",13,10,10,"$"
;
DOESTHETRICK:	DB	#03,#C9,#09,#00	;Send( variable header.
	DB	#00,#00,#13,#00,#00,#00,#00,#00,#00	;Variable-header...
	DB	#13,#00,#FF	;Checksum + end.
REPLY_OK:	DB	#03,#56,#00,#00	;OK reply
	DB	#FF	;end.




s00:	equ	%00001100
s01:	equ	%00001101	;Send values
s10:	equ	%00001110
s11:	equ	%00001111
r00:	equ	%00000000	;Recieve comparisation values
r01:	equ	%00010000	;(after AND r11)
r10:	equ	%00100000
r11:	equ	%00110000
;
Send_TI:	MACRO	@value
	ld	a,15
	out	(#A0),a
	ld	a,@value
	out	(#A1),a
	ENDM
Recv_TIa:	MACRO
	ld	a,14
	out	(#A0),a
	ENDM
Recv_TIb:	MACRO
	in	a,(#A2)
	ENDM

SetTestESC:	MACRO
	in	a,(#aa)
	and	#F0
	or	7
	out	(#aa),a
	ENDM
DoTestESC:	MACRO
	in	a,(#a9)
	bit	2,a
	ENDM



;
;==============================================================================
;= Transmission routines ======================================================
;==============================================================================
;
;The following routines are included:
; - RecvByte: Recieves a byte from the TI calculator
; - SendByte: Sends a byte to the TI calculator
;
;
;This routine recieves a byte from the TI-83...
;Result: A=recieved byte.
;        Carry=Error. If error then:
;         - if A=0 / the Z flag is set then the transmission was aborted.
;         - if A=255 / the Z flag is not set then a transmission error occurred.
;
;Changes: AF, BC
;
;!!! NEVER USE DE !!! otherwise adapt other routines.
;
RecvByte:	di
	Send_TI	s11	;Make sure pins are set right to recieve.
	ld	b,8	;B=bitcounter, C=byte to be filled...
	ld	c,0
RecvByteLoop:	SetTestESC	;Prepare ESC readout & Joy readout
	Recv_TIa
RecvByte_Lop:	DoTestESC
	jp	z,Xmit_Abort
	Recv_TIb
	and	r11
	cp	r11
	jp	z,RecvByte_Lop
	cp	r01
	jp	z,Recv_0bit	;Some kind of CALL...
	jp	nc,Recv_1bit
	jp	c,Xmit_Error
RecvByteCont:	djnz	RecvByteLoop	;...which returns HERE!!!
	ei
	ld	a,c
	ret



;Recieve a 0-bit.
;
Recv_0bit:	rrc	c	;Leave bit 0...
	Send_TI	s10
	SetTestESC	;Prepare ESC readout & Joy readout
	Recv_TIa
Recv_0_Loop:	DoTestESC
	jp	z,Xmit_Abort
	Recv_TIb
	and	r10
	jp	z,Recv_0_Loop
	Send_TI	s11
	jp	RecvByteCont


;Recieve a 1-bit.
;
Recv_1bit:	rrc	c
	set	7,c	;Set bit to 1...
	Send_TI	s01
	SetTestESC	;Prepare ESC readout & Joy readout
	Recv_TIa
Recv_1_Loop:	DoTestESC
	jp	z,Xmit_Abort
	Recv_TIb
	and	r01
	jp	z,Recv_1_Loop
	Send_TI	s11
	jp	RecvByteCont




;
;This routine sends a byte to the TI-83...
;Input: A=byte to send...
;Result: Carry=Error. If error then:
;         - if A=0 / the Z flag is set then the transmission was aborted.
;         - if A=255 / the Z flag is not set then a transmission error occurred.
;
;Changes: AF, BC
;
;
SendByte:	ld	b,8
	ld	c,a
	di
SendByteLoop:	rrc	c
	jp	nc,Send_0bit
	jp	c,Send_1bit
SendByteCont:	djnz	SendByteLoop
	ei
	ret



;Send a 0-bit.
;
Send_0bit:	Send_TI	s01
	SetTestESC	;Prepare ESC readout & Joy readout
	Recv_TIa
Send_0_Loop1:	DoTestESC
	jp	z,Xmit_Abort
	Recv_TIb
	and	r01
	jp	nz,Send_0_Loop1
	Send_TI	s11
	SetTestESC	;Prepare ESC readout & Joy readout
	Recv_TIa
Send_0_Loop2:	DoTestESC
	jp	z,Xmit_Abort
	Recv_TIb
	and	r01
	jp	z,Send_0_Loop2
	jp	SendByteCont



;Send a 1-bit.
;
Send_1bit:	Send_TI	s10
	SetTestESC	;Prepare ESC readout & Joy readout
	Recv_TIa
Send_1_Loop1:	DoTestESC
	jp	z,Xmit_Abort
	Recv_TIb
	and	r10
	jp	nz,Send_1_Loop1
	Send_TI	s11
	SetTestESC	;Prepare ESC readout & Joy readout
	Recv_TIa
Send_1_Loop2:	DoTestESC
	jp	z,Xmit_Abort
	Recv_TIb
	and	r10
	jp	z,Send_1_Loop2
	jp	SendByteCont



;
;==============================================================================
;= Other routines =============================================================
;==============================================================================
;
;Error routines: Xmit_Abort & Xmit_Error.
;
Xmit_Error:	ld	de,ERR_XMIT	;Transmission error...
	ld	c,9
	call	Bdos
	ld	sp,(save_SP)
	ret

Xmit_Abort:	ld	de,ERR_ABORT	;Transmission error...
	ld	c,9
	call	Bdos
	ld	sp,(save_SP)
	ret

;
;
ERR_XMIT:	DB	13,10,"*** Transmission Error...",13,10,10,"$"
ERR_ABORT:	DB	13,10,"*** Aborted by user.",13,10,10,"$"
;
save_SP:	DW	#0000
;


;
;
;
Einde:	END
